//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "Proxy")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false, column_type = "Text")]
    pub domain: String,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
    #[sea_orm(column_name = "acmeAccountId")]
    pub acme_account_id: Option<Uuid>,
    #[sea_orm(column_name = "parentDomainName")]
    pub parent_domain_name: Option<Uuid>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::acme_account::Entity",
        from = "Column::AcmeAccountId",
        to = "super::acme_account::Column::Id",
        on_update = "Cascade",
        on_delete = "SetNull"
    )]
    AcmeAccount,
    #[sea_orm(
        belongs_to = "super::domain::Entity",
        from = "Column::ParentDomainName",
        to = "super::domain::Column::Id",
        on_update = "Cascade",
        on_delete = "SetNull"
    )]
    Domain,
    #[sea_orm(has_many = "super::route::Entity")]
    Route,
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::acme_account::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::AcmeAccount.def()
    }
}

impl Related<super::domain::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Domain.def()
    }
}

impl Related<super::route::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Route.def()
    }
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
